//+------------------------------------------------------------------+
//|                                             VininI_SMA_Canal.mq4 |
//|                                         Copyright  2012, Vinin. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Vinin."
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Yellow
//--- input parameters
extern int       CalcBar=24;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);

   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i, limit1=Bars-counted_bars-1;
   int limit2=limit1;
   if (limit1>1) {
      limit2-=CalcBar;
   }
   
   for (i=limit1;i>=0;i--) {
      ExtMapBuffer4[i]=iMA(NULL, 0, CalcBar, 0, MODE_SMA, PRICE_HIGH, i);
      ExtMapBuffer5[i]=iMA(NULL, 0, CalcBar, 0, MODE_SMA, PRICE_LOW,  i);
   }
   for (i=limit2;i>=0;i--) {
      ExtMapBuffer1[i] = ExtMapBuffer4[ArrayMaximum(ExtMapBuffer4, CalcBar, i)];
      ExtMapBuffer2[i] = ExtMapBuffer5[ArrayMinimum(ExtMapBuffer5, CalcBar, i)];
      ExtMapBuffer3[i] =(ExtMapBuffer1[i]+ExtMapBuffer2[i])*0.5;

   }
   return(0);
  }
//+------------------------------------------------------------------+